indexing
	description: "An item that can be held in an AEL_DS_CACHE"
	license: "Eiffel Forumn License v2 - See license.txt"
	source: "{
		Amalasoft Corporation
		273 Harwood Avenue
		Littleton, MA 01460 USA
		}"
	status: "Copyright 1995-2008, Amalasoft";
	date: "$Date: 2008/12/03 $";
	revision: "$Revision: 001$";
	howto: "{
    This class should be inherited by any class to be cached.
}"

deferred class AEL_DS_CACHEABLE

--|========================================================================
feature {NONE} -- Initialization
--|========================================================================

	make_with_cache_key (v: like cache_key) is
			-- Create Current with the key 'v'
		require
			is_valid_cache_key: is_valid_cache_key (v)
		deferred
		end

--|========================================================================
feature -- Status
--|========================================================================

	cache_key: HASHABLE is
			-- Key by which Current will be identified in a cache
		deferred
		end

	--|--------------------------------------------------------------

	is_valid_cache_key (v: like cache_key): BOOLEAN is
			-- Is the given value a valid cache key?
		deferred
		end

	--|--------------------------------------------------------------
invariant
	key_exists: cache_key /= Void
	key_valid: is_valid_cache_key (cache_key)

end -- class AEL_DS_CACHEABLE

